
PROGRAM PISQORKY;

{pouzite algoritmy: program po kazdem tahu ohodnoti okolni pole hraci plochy
(matice 5*5 poli) a vybere pole s nejvetsim ohodnocenim.}


{$R+}
USES Crt,Graph;

CONST n = 20;                       {rozmer hraciho pole}
      policko = 20;                 {velikost 1 policka na obrazovce}
      posx = 100;
      posy = 40;                    {levy horni roh mrizky}
      zac : array [1..2] of byte = (posx+7,posy+7);

TYPE pole = array[1..n,1..n] of integer;
     souradnice = 1..n;

VAR Gd, Gm : integer;               {grafika}
    plocha,vahy : pole;
    player : string[6];
    hrac : 1..2;                    {1: pocitac; 2:hrac}
    s,i,j,k : integer;              {pomocne prom}
    x,y : souradnice;               {pozice hracova kurzoru}
    xc,yc : souradnice;             {souradnice pocitace (compu)}
    Smer : array [1..4] of record
                             x1 : -1..1;
                             y1 : -1..1;
                           end;
    SmerNr : 0..4;
    ch,volba,VolbaznakP,VolbaznakC: char;                 {pomocne prom}
    ok : boolean;
    KonecHry : boolean;



procedure Vynuluj(var plocha,vahy : pole);
var i,j : 1..n;
begin
 for i:=1 to n do
 for j:=1 to n do
  begin
   plocha[i,j]:=0;
   vahy[i,j]:=0;
  end;
end;


procedure Konec;                    {zakonceni hry}
begin
 CloseGraph;
 halt;
end;


procedure Draw(posx1,posy1: integer);     {kursor}
const uk=policko-2;
begin
 Rectangle(posx1,posy1,posx1+uk,posy1+uk);
 line(posx1,posy1,posx1+uk,posy1+uk);
 line(posx1+uk,posy1,posx1,posy1+uk);
end;


procedure Ukazatel(x,y : souradnice);
const uk = policko-2;
var posx1, posy1 : integer;
    s1,s2 : boolean;

 procedure Refresh(x,y : souradnice);
 begin
  if plocha[x,y]=2 then
    begin
     SetColor(10);
     OutTextXY(zac[1]+policko*(x-1)-1 ,zac[2]+policko*(y-1) - 9,VolbaznakP); {hrac}
    end;
  if plocha[x,y]=1 then
    begin
     SetColor(9);
     OutTextXY(zac[1]+policko*(x-1)-1, zac[2]+policko*(y-1) - 9,VolbaznakC); {pocitac}
    end;
 end;

begin
 s1:=false;s2:=false;
 if (x+Smer[SmerNr].x1<=n) and (x+Smer[SmerNr].x1>=1) then s1:=true;
 if (y+Smer[SmerNr].y1<=n) and (y+Smer[SmerNr].y1>=1) then s2:=true;
 if s1 and s2 then begin
  SetColor(0);                      {cerna - smazat puvodni kurzor}
  posx1:=posx + policko*(x-1) + 1;
  posy1:=posy + policko*(y-1) + 1;
  Draw(posx1,posy1);
  Refresh(x,y);
  SetColor(4);                      {ruda barva kurzoru - nakresli na novou pozici}
  posx1:=posx1 + Smer[SmerNr].x1*policko;
  posy1:=posy1 + Smer[SmerNr].y1*policko;
  Draw (posx1,posy1);
 end;
end;


procedure Poloz(x,y : souradnice);  {polozi hraci kamen na souradnice x,y}
begin
 plocha[x,y]:=hrac;                 {1 pocitac; 2 hrac}
 if plocha[x,y]=2 then
  begin
   SetColor(10);
   OutTextXY(zac[1]+policko*(x-1)-1 ,zac[2]+policko*(y-1) - 9,VolbaznakP); {hrac}
   Sound(220);
   Delay(40);
   Nosound;
   Delay(300);
  end
 else
  begin
   SetColor(9);
   OutTextXY(zac[1]+policko*(x-1)-1, zac[2]+policko*(y-1) - 9,VolbaznakC);{pocitac}
   Sound(500);
   Delay(40);
   Nosound;
  end;
 vahy[x,y]:=0;
end;


procedure VyhodKlav(ch : char);     {vstup z klavesnice}
begin
 ok:=true;
 case ch of
 #0   : begin
         ch:=readkey;
         if ch=#72 then SmerNr:=1;  {nahoru}
         if ch=#77 then SmerNr:=2;  {dolu}
         if ch=#80 then SmerNr:=3;  {doprava}
         if ch=#75 then SmerNr:=4;  {doleva}
        end;
 #13  : if plocha[x,y]=0 then begin
           poloz(x,y);
           end
        else ok:=false;             {enter - spusti se procedura, ktera vlozi znak}
 #27  : konec;                      {escape - konec hry}
 else begin
      ok:= false;SmerNr:=0;
      end;
 end;
end;


procedure UpdateSouradnice;
var s1,s2 : boolean;
begin
 s1:=false;s2:=false;
 if (x+Smer[SmerNr].x1>=1) and (x+Smer[SmerNr].x1<=n) then s1:=true;
 if (y+Smer[SmerNr].y1>=1) and (y+Smer[SmerNr].y1<=n) then s2:=true;
 if s1 and s2 then begin
  x:=Smer[SmerNr].x1+x;
  y:=Smer[SmerNr].y1+y;
 end;
end;


procedure DrawScale;                {kresleni hraci plochy}
var i,j :0..n;
begin
SetBKColor(0);
SetColor(3);
for i:= 0 to n do
  Line (posx,i*policko+posy,posx+policko*n,i*policko+posy);  {vykresleni vodorovnych car}
 for j:= 0 to n do
  Line (j*policko+posx,posy,j*n+posx,policko*n+posy); {... svislych ...}
SetTextStyle(Smallfont,HorizDir,12);
SetColor(1);
OutTextXY(5,30,'COMP');             {obrazek pocitace}
Rectangle(22,85,72,120);Rectangle(25,88,69,117);Rectangle(22,125,72,145);
Rectangle(32,120,62,125);Line(27,130,47,130);Line(35,110,59,110);
Circle(37,100,3);Circle(57,100,3);
SetColor(10);
OutTextXY(511,30,Player);           {obrazek playera}
Circle(570,115,30);Circle(552,105,3);Circle(588,105,3);Line(550,125,590,125);
SetTextStyle(TriplexFont,Horizdir,10);
OutTextXY(540,130,VolbaznakP);
SetColor(1);
OutTextXY(10,130,VolbaznakC);
end;


procedure Vazeni(x,y : souradnice; var vahy : pole);
type radka = array[0..4] of 0..2;
var x1,y1 : souradnice;
    petice : radka;
    i: integer;

function ohodnot_petici(petice: radka): integer;
var comp,player : byte;
    i : integer;
begin
 comp:=0;player:=0;
 for i:=0 to 4 do
 begin
  if petice[i]=1 then inc(comp);
  if petice[i]=2 then inc(player);
 end;
 if (comp>0) and (player>0) then ohodnot_petici:=0
 else
 case comp of
  1 : ohodnot_petici :=1;
  2 : ohodnot_petici :=6;
  3 : ohodnot_petici :=25;
  4 : ohodnot_petici :=100;
  5 : KonecHry := true;
  end;
 if comp=0 then
 case player of
  1 : ohodnot_petici:=1;
  2 : ohodnot_petici:=4;
  3 : ohodnot_petici:=15;
  4 : ohodnot_petici:=80;
  5 : KonecHry := true;
 end;
 if (comp=0) and (player=0) then ohodnot_petici:=0;
end;

begin
 vahy[x,y]:=0;

                                    {svisla ohodnoceni:}
 x1:=x;
 while (x1>1) and ((x-x1)<4) do dec(x1);
 while (x1+4<=n) and (x1<=x) do
  begin
   for i:=0 to 4 do
    begin
     petice[i]:=plocha[x1+i,y];
    end;
   vahy[x,y]:=ohodnot_petici(petice)+vahy[x,y];
   inc(x1);
   end;

                                    {vodorovna ohodnoceni}
 y1:=y;
 while (y1>1) and (y-y1<4) do dec(y1);
 while (y1+4<=n) and (y1<=y) do
  begin
   for i:=0 to 4 do
    begin
     petice[i]:=plocha[x,y1+i];
    end;
    vahy[x,y]:=ohodnot_petici(petice)+vahy[x,y];
    inc(y1);
  end;

                                    {sestupna ...}
 y1:=y;x1:=x;
 while (y1>1) and (x-x1<4) and (x1>1) and (y-y1<4) do
  begin
   dec(y1);dec(x1);
  end;
 while (y1+4<=n) and (y1<=y) and (x1+4<=n) and (x1<=x) do
  begin
  for i:=0 to 4 do
   begin
    petice[i]:=plocha[x1+i,y1+i];
   end;
   vahy[x,y]:=ohodnot_petici(petice)+vahy[x,y];
   inc(x1);inc(y1);
  end;

                                    {vzestupna ....}
 y1:=y;x1:=x;
 while (y1>1) and (x1<20) and (y-y1<4) and (x1-x<4) do
  begin dec(y1); inc(x1); end;
 while (x1-4>=1) and (y1+4<=20) and (y1<=y) and (x<=x1) do
  begin
   for i:=0 to 4 do
    begin
     petice[i]:=plocha[x1-i,y1+i];
    end;
    vahy[x,y]:=ohodnot_petici(petice)+vahy[x,y];
    inc(y1);dec(x1);
  end;
end;


procedure CheckPoints(x,y: souradnice);
                                    {ohodnoceni bezprostrednich bodu v okoli souradnic [x,y]}
var x1,y1,radx,rady: shortint;
begin                               {nestaci ohodnotit pouze policka v bezp. blizkosti...
                                     je nutne ohodnotit ctverec o strane az 11}
 x1:=x-4;y1:=y-4;                   {levy horni roh}
 radx:=9;rady:=9;
 while x1<1 do begin inc(x1);dec(radx);end;  {aby se vesly do hraci plochy}
 while y1<1 do begin inc(y1);dec(rady);end;
 while (x1+ radx ) >20 do dec(radx);
 while (y1+ rady ) >20 do dec(rady);
 for i:=x1 to x1+radx do
  for j:=y1 to y1+rady do
   if plocha[i,j]=0 then Vazeni(i,j,vahy);
end;


procedure FindMax(vahy : pole);
var i,j,k,l : souradnice;
    max:integer;
begin
 max:=0;
 for i:=1 to n do
  for j:=1 to n do
  if vahy[i,j]>max then
     begin
      max:=vahy[i,j];
      xc:=i;
      yc:=j;
end;
end;



BEGIN                               {vlastni program}
clrscr;

Gd:=DETECT;
Gm:=detect;
InitGraph (Gd,gm,'');
ClearDevice;
SetBKColor(0);
SetColor(1);
SetTextStyle(TriplexFont,HorizDir,9);
OutTextXY (65,70,'PISQvORKY');
SetTextStyle(TriplexFont,HorizDir,4);
SetColor(4);
OutTextXY (150,185, 'by TOMik Prosecky');
Rectangle (60,75,560,170);
Setcolor(2);
Line (160,85,175,95); Line (175,95,190,85);
Line (440,197,450,190);
SetColor(1);
Line (168,267,176,267);Line (326,287,334,287); Line (270,416,278,416);
SetTextStyle(Smallfont,HorizDir,7);
SetColor(1);
OutTextXY (120,260, 'Zapoctovy program za letni semestr');
OutTextXY (120,280, 'Fyzika Mgr., 1. rocnik, skupina 14');
OutTextXY (240,300, '25.8.2000');
OutTextXY (210,410, 'Pokracovat?  A/N');
SetTextStyle (TriplexFont,HorizDir,10);
OutTextXY (65,340, 'X');
SetColor(2);
OutTextXY (490,340, 'O');

repeat
  volba:=readkey;
until (volba='a') or (volba='n');
if volba = 'n' then konec;

ClearDevice;                        {druha obrazovka, pravidla}
SetColor (1);
SetTextStyle (Smallfont,HorizDir,6);
OutTextXY (30,12, 'Vase jmeno???'); {vstup playerova jmena}
Textcolor(2);
Writeln('');
Write('                       ');
Read(player);
OutTextXY (30,32, 'Chcete O nebo X ???');
Write('                            ');
repeat
  VolbaznakP:=readkey;
until (VolbaznakP='o') or (VolbaznakP='x');
If VolbaznakP = 'o' then VolbaznakP := 'O';
If VolbaznakP = 'x'then
  begin
  VolbaznakC := 'O';
  VolbaznakP := 'X';
  end
else VolbaznakC := 'X';
OutTextXY ( 30,90, ' Vitejte!  Pravidla hry PISQvORKY jsou snad kazdemu jasna,');
OutTextXY (30,110, 'ale pro jistotu si je zopakujeme...  Ucelem hry je porazit');
OutTextXY (30,130, 'protihrace  (zde COMP), tedy vytvorit souvislou radu O resp.');
OutTextXY (30,150, 'X drive nez dotycny protihrac. Souvisla rada je tedy 5-tice');
OutTextXY (30,170, 'znaku vedle sebe ve smeru vodorovnem, kosmem, sikmem neb');
OutTextXY (30,190, 'svislem. Pohyb po hraci plose se ovlada pomoci sipek, znak');
OutTextXY (30,210, 'se poklada pomoci <ENTER>. Hru je mozne kdykoliv prerusit');
OutTextXY (30,230, 'stisknutim klavesy <ESC>.');
OutTextXY (30,270, 'Preji prijemnou zabavu!');
OutTextXY (30,400, 'Pokracujte stiskem libovolne klavesy...');
repeat until keypressed;
Cleardevice;

repeat                              {vlastni hra}
Cleardevice;
  KonecHry :=false;
  hrac:=2;                          {zacina hrac}
  SmerNr:=0;
  x:=10;y:=10;xc:=x;yc:=y;
  Vynuluj (plocha,vahy);
  Smer[1].x1:=0;                    {nahoru}
  Smer[1].y1:=-1;
  Smer[2].x1:=1;                    {doprava}
  Smer[2].y1:=0;
  Smer[3].x1:=0;                    {dolu}
  Smer[3].y1:=1;
  Smer[4].x1:=-1;                   {doleva}
  Smer[4].y1:=0;

  DrawScale;
  SetTextStyle(SmallFont,HorizDir,7);
  SetColor(4);
  Draw((posx + policko*(x-1) + 1),(posy + policko*(y-1) + 1));
  while not KonecHry do
   begin
    case hrac of
    2 :  begin                      {hrac}
          repeat
          ok:=false;
          while not ok do begin
                 ch:=readkey;
                 VyhodKlav(ch);
                end;
          if SmerNr<>0 then
           begin
              Ukazatel(x,y);
              UpdateSouradnice;
           end;
          SmerNr:=0;
         until ch=#13; {enter}
         Vazeni(x,y,vahy);          {neudelal petici?}
         vahy[x,y]:=0
        end;

    1 :                             {Pocitac : staci ohodnocovat body v bezprostredni blizkosti toho,
                                     kde hral hrac}
                                    {provede se ohodnoceni 8 bodu okolo [x,y]:}
       begin
        if not konechry then
         begin CheckPoints(x,y); {vyhodnoti okolni body}
               FindMax(vahy);{max se ulozi do [xc,yc]}
               poloz(xc,yc);{ulozi se tah}
               Vazeni(xc,yc,vahy);  {nevyhral jsem? : KonecHry:=true}
               vahy[xc,yc]:=0;
               Checkpoints(xc,yc);  {ohodnoceni okoli meho tahu}
               vahy[xc,yc]:=0;
         end;
       end;
  end;
 if not KonecHry then begin if hrac=2 then hrac:=1 else hrac:=2;end;
 end;
 SetTextStyle(SmallFont,HorizDir,5);
 if hrac=2 then begin               {vitezstvi krace}
  OutTextXY(165,10,'Vyhral jsi. <ENTER> pro dalsi hru.');
  Rectangle(155,0,440,30);  {oramovani}
  Line(550,124,550,118);Line(590,124,590,118);
  SetColor(1);
  Rectangle(35,105,59,110);
  Sound(400);Delay(200);
  Sound(520);Delay(200);
  Sound(650);Delay(200);
  Sound(800);Delay(800);Nosound;
  end
 else begin
  SetColor(1);                      {vitezstvi pocitace}
  OutTextXY(165,10,'Vyhral jsem. <ENTER> pro dalsi hru. ');
  Rectangle(155,0,440,30);  {oramovani}
  Line(35,110,35,106);Line(59,110,59,106);
  SetColor(10);
  Rectangle(550,119,590,125);
  for s:=1 to 3 do begin
  Sound(130);Delay(350);Nosound;Delay(70);
  end;
  Sound(85);Delay(900);Nosound;
      end;
 repeat
 ch:=readkey;                       {volba nove hry}
 until (ch=#13) or (ch=#27);
 if ch=#27 then Konec;
 until ch<>#13;
END.
